# OFFENSIVE SECURITY & REVERSE ENGINEERING (OSRE) Course

This repository is for the Offensive Security and Reverse Engineering ~~Offensive Software Exploitation~~ Course I used to teaching at Champlain College and currently sharing it for free online (check the YouTube channel for the recordings). Most of the slidenotes I used, are already shared on [HTID Course](http://opensecuritytraining.info/HTID.html), but the labs were fully created by myself. I used publicly available resources and software to explain each of the weakneses covered, so there is nothing here that you cannot find online.

---
### OFFENSIVE SECURITY & REVERSE ENGINEERING (FULL COURSE)
This is the whole course that was covered at Champlain College during Spring 20/21, yes during the COVID-19 pandemic! Unfortunately I was not able to cover all the modules due to time limitation, but other than that I had a great semester with my students and enjoyed teaching this course to them. Big thank you to each one of them, who all graduated now. The course could be found here [OSRE](https://github.com/ashemery/exploitation-course/tree/master/course/2021). The videos on my YouTube channel walk through most of them.

---
### Vulnerable Software
The vulnerable software I used are also online and can be found at [Exploit-db](https://www.exploit-db.com/). I also used Stephen Bradshaw's [VulnServer](https://github.com/stephenbradshaw/vulnserver), plus maybe some other simple code that I prepared. Please check each lab for the software used in that specific lab and from where to download it.

---
### Tool(s) Required
All of the tools used are free and could be downloaded from the URLs below.
- Immunity Debugger: [download](https://www.immunityinc.com/products/debugger/)
- Kali Linux: [download](https://www.kali.org/)
- CFF Explorer: [download](https://ntcore.com/?page_id=388)
- PE-bear: [download](https://github.com/hasherezade/pe-bear-releases)
- Ghidra: [download](https://ghidra-sre.org/)
- IDA Free/Demo: [download](https://www.hex-rays.com/ida-free/)
- x64dbg: [download](https://x64dbg.com/#start)
- Microsoft SysInternals Suite: [download](https://docs.microsoft.com/en-us/sysinternals/)
- CAPA by FireEye FLARE Team: [download](https://github.com/fireeye/capa)
- NetCat: [download](https://joncraton.org/blog/46/netcat-for-windows/)
- Others!

---
### Target(s) Used
- Download a Windows 10 VM from Microsoft VMs (currently using Version 1809 Build 17763.1339) [here](https://developer.microsoft.com/en-us/microsoft-edge/tools/vms/). This will be used for most of the labs, except for the EggHunter lab, I used a Windows 7 VM, also from Microsoft VMs (currently offline so check archive.org).
- All the targeted software is Intel/AMD 32-bit unless otherwise instructed.

---
### Table of Contents:
The topics that will be covered in this course are:
1.  The Basics (PE Format, DLLs, etc)
2.  Bug Hunting and Fuzzing
3.  Intro. to Memory Corruption and Buffer Overflows
4.  Metasploit
5.  Mitigation Techniques
6.  SEH and Jumping Strategies
7.  Egghunter
8.  Retrurn Oriented Programming (ROP)
9.  Post Exploitation
10. Manual Code Injection
11. Intro. to Assembly x86 and x64 (please check update #3 for this part)
12. Reverse Engineering (please check update #3 for this part)

---
### Video Recordings:
- Arabic version: [Playlist](https://www.youtube.com/playlist?list=PLCS2zI95IiNyo5AhbVIL2hVX7zhuSkOkz)
- English version: [Playlist](https://www.youtube.com/playlist?list=PLCS2zI95IiNybAAQ0HL88YzwRpLXje5y6)

---
### Useful Resources:
- The number one resource is the Corelan Team's blog, [Corelan Team](https://www.corelan.be/)
- Architecture 1001: x86-64 Assembly, [OpenSecurityTraining2](https://ost2.fyi/Arch1001)

---
### Update(s):
- [1] ~~On Aug. 6th, 2020 both [eLearnSecurity](https://www.elearnsecurity.com/) and [INE](https://www.ine.com/) decided to sponsor the English version of the course and therefore will be recording an English version too.~~ 
- [2] Nov. 10th, 2020: will sponsor it myself, since I left working for eLearnSecurity.
- [3] Nov. 30th, 2020: this course will be taught next semester (Spring 2021) at Champlain College, with a slight difference, the Reverse Engineering section.
- [4] Jul. 1st, 2021: publishing the whole course that was covered at Champlain College during Spring 20/21, yes during the COVID-19 pandemic!

### Credits:
Thanks to everyone who shared their work online, without them this course would not have happened!


